Attribute VB_Name = "modTreeView"
' Modulname : vbzTreeView.bas
' Version   : 1.0
' Stand     : 23.02.2011
' Quelle    : http://www.vb-zentrum.de

' Hinweis:
' bentigt die Microsoft Windows Common Controls 5.0(SP2) - comctl32.ocx,
' da viele Funktionen, wie z.B. "tvwSetExtendedStyle" von der Version 6.0
' NICHT untersttzt werden!

Option Explicit

' Konstanten:
Private Const TV_FIRST = &H1100
Private Const TVM_INSERTITEM = TV_FIRST + 0
Private Const TVM_DELETEITEM = TV_FIRST + 1
Private Const TVM_EXPAND = TV_FIRST + 2
Private Const TVM_GETITEMRECT = TV_FIRST + 4
Private Const TVM_GETCOUNT = TV_FIRST + 5
Private Const TVM_GETINDENT = TV_FIRST + 6
Private Const TVM_SETINDENT = TV_FIRST + 7
Private Const TVM_GETIMAGELIST = TV_FIRST + 8
Private Const TVM_SETIMAGELIST = TV_FIRST + 9
Private Const TVM_GETNEXTITEM = TV_FIRST + 10
Private Const TVM_SELECTITEM = TV_FIRST + 11
Private Const TVM_GETITEM = TV_FIRST + 12
Private Const TVM_SETITEM = TV_FIRST + 13
Private Const TVM_EDITLABEL = TV_FIRST + 14
Private Const TVM_GETEDITCONTROL = TV_FIRST + 15
Private Const TVM_GETVISIBLECOUNT = TV_FIRST + 16
Private Const TVM_HITTEST = TV_FIRST + 17
Private Const TVM_CREATEDRAGIMAGE = TV_FIRST + 18
Private Const TVM_SORTCHILDREN = TV_FIRST + 19
Private Const TVM_ENSUREVISIBLE = TV_FIRST + 20
Private Const TVM_SORTCHILDRENCB = TV_FIRST + 21
Private Const TVM_ENDEDITLABELNOW = TV_FIRST + 22
Private Const TVM_GETISEARCHSTRING = TV_FIRST + 23
Private Const TVM_SETTOOLTIPS = TV_FIRST + 24
Private Const TVM_GETTOOLTIPS = TV_FIRST + 25
Private Const TVM_SETINSERTMARK = TV_FIRST + 26
Private Const TVM_SETITEMHEIGHT = TV_FIRST + 27
Private Const TVM_GETITEMHEIGHT = TV_FIRST + 28
Private Const TVM_SETBKCOLOR = TV_FIRST + 29
Private Const TVM_SETTEXTCOLOR = TV_FIRST + 30
Private Const TVM_GETBKCOLOR = TV_FIRST + 31
Private Const TVM_GETTEXTCOLOR = TV_FIRST + 32
Private Const TVM_SETSCROLLTIME = TV_FIRST + 33
Private Const TVM_GETSCROLLTIME = TV_FIRST + 34
Private Const TVM_SETINSERTMARKCOLOR = TV_FIRST + 37
Private Const TVM_GETINSERTMARKCOLOR = TV_FIRST + 38
Private Const TVM_GETITEMSTATE = TV_FIRST + 39
Private Const TVM_SETLINECOLOR = TV_FIRST + 40
Private Const TVM_GETLINECOLOR = TV_FIRST + 41
Private Const TVM_MAPACCIDTOHTREEITEM = TV_FIRST + 42
Private Const TVM_MAPHTREEITEMTOACCID = TV_FIRST + 43
Private Const TVM_SETEXTENDEDSTYLE = TV_FIRST + 44
Private Const TVM_GETEXTENDEDSTYLE = TV_FIRST + 45

' TreeView styles
Public Enum TVW_STYLES
  TVS_CHECKBOXES = &H100
  TVS_DISABLEDRAGDROP = &H10
  TVS_EDITLABELS = &H8
  TVS_FULLROWSELECT = &H1000
  TVS_HASBUTTONS = &H1
  TVS_HASLINES = &H2
  TVS_INFOTIP = &H800
  TVS_LINESATROOT = &H4
  TVS_NOSCROLL = &H2000
  TVS_NOTOOLTIPS = &H80
  TVS_SHOWSELALWAYS = &H20
  TVS_SINGLEEXPAND = &H400
  TVS_TRACKSELECT = &H200
  TVS_NONEVENHEIGHT = &H4000&
  TVS_NOHSCROLL = &H8000&
End Enum
' Extended TreeView styles:
Public Enum TVW_EX_STYLES
  TVS_EX_DOUBLEBUFFER = &H4&
  TVS_EX_AUTOHSCROLL = &H20&
  TVS_EX_FADEINOUTEXPANDOS = &H40&      ' minimum OS: Vista (header in all views)!
End Enum

Private Const GWL_EXSTYLE As Long = -20
Private Const GWL_HINSTANCE As Long = -6
Private Const GWL_HWNDPARENT As Long = -8
Private Const GWL_ID As Long = -12
Private Const GWL_STYLE As Long = -16
Private Const GWL_USERDATA As Long = -21
Private Const GWL_WNDPROC As Long = -4

Private Const SWP_DRAWFRAME = &H20
Private Const SWP_NOMOVE = &H2
Private Const SWP_NOSIZE = &H1
Private Const SWP_NOZORDER = &H4
Private Const SWP_FLAGS = SWP_NOZORDER Or SWP_NOSIZE Or SWP_NOMOVE Or SWP_DRAWFRAME

' Declaration window and system functions:
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, _
        ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Declare Function SendMessageLong Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, _
        ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function GetParent Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" ( _
        ByVal hwnd As Long, ByVal nIndex As Long) As Long
Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, _
        ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Declare Function FindWindowEx Lib "user32" Alias "FindWindowExA" (ByVal hWnd1 As Long, _
        ByVal hWnd2 As Long, ByVal lpsz1 As String, ByVal lpsz2 As String) As Long

' *** Begin XP themes and styles
Private Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long
Private Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule As Long) As Long
Private Declare Function SetWindowTheme Lib "uxtheme" (ByVal hwnd As Long, ByVal pSubAppName As Long, _
        ByVal pSubIDList As Long) As Long
Private Enum puxTHEME
  uxUNKNOWN = &H0&
  uxNONE = &H1&
  uxOKAY = &H2&
End Enum
Private uxtheme As puxTHEME
' *** End XP themes


' TreeView ExplorerStyle, only for Common Controls 5.0
' Needs WinXP or newer. (Effect doesn't exist in IDE!)
Public Function tvwSetExplorerStyle(ByVal hwnd As Long) As Boolean
  Dim hModule As Long
  ' check if uxtheme.dll exist (only once a session for better performance!)
  If uxtheme = uxUNKNOWN Then                   ' function called first time
    hModule = LoadLibrary("uxtheme.dll")        ' try to load uxtheme.dll
    If hModule Then                             ' if exist, then
      uxtheme = uxOKAY                          ' keep success in memory
      FreeLibrary hModule                       ' and unload the library
    Else
      uxtheme = uxNONE                          ' keep info: no theme dll
    End If
  End If
  
  If uxtheme = uxOKAY Then                      ' if dll exist (see above)
    SetWindowTheme hwnd, StrPtr("explorer"), 0  ' set the explorer style
    tvwSetExplorerStyle = True                  ' and return "TRUE"
  End If
End Function

' TreeView style extensions, only Common Controls 5.0
Public Sub tvwSetStyle(ByVal hwnd As Long, ByVal lStyle As TVW_STYLES, ByVal flag As Boolean)
  Dim mask As Long
  
  mask = GetWindowLong(hwnd, GWL_STYLE)
  If flag Then                  ' switch on style
    mask = mask Or lStyle
  Else                          ' switch off
    mask = mask And Not lStyle
  End If
  SetWindowLong hwnd, GWL_STYLE, mask
  SetWindowPos hwnd, GetParent(hwnd), 0, 0, 0, 0, SWP_FLAGS
End Sub

' TreeView style extensions, only Common Controls 5.0
Public Sub tvwSetExtendedStyle(ByVal hwnd As Long, ByVal lStyle As TVW_EX_STYLES, ByVal flag As Boolean)
  Dim mask As Long
  
  mask = SendMessageLong(hwnd, TVM_GETEXTENDEDSTYLE, 0&, 0&)
  If flag Then                                    ' switch on style
    If lStyle And TVS_EX_FADEINOUTEXPANDOS Then   ' if style includes TVS_EX_FADEINOUTEXPANDOS
      lStyle = lStyle Or TVS_EX_DOUBLEBUFFER      ' then TVS_EX_DOUBLEBUFFER and
      tvwSetStyle hwnd, TVS_TRACKSELECT, True     ' TVS_TRACKSELECT must be activated
    End If
    mask = mask Or lStyle                         ' create mask with new style
  Else                                            ' switch off
    mask = mask And Not lStyle                    ' delete style in mask bits
  End If
  SendMessageLong hwnd, TVM_SETEXTENDEDSTYLE, ByVal 0&, ByVal mask
End Sub
